//
//  TransactionsViewController.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/5/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit
import RxSwift
import RxCocoa
import RxDataSources
import Differentiator

protocol TransactionsPresenterInterface: PresenterInterface {
    var backTrigger: PublishRelay<Void> { get }
}

final class TransactionsViewController: UIViewController, TransactionsViewInterface {
    
    @IBOutlet weak var pinBottonContainerWrapView: UIView!
    
    @IBOutlet weak var submitButton: DSButton!
    // MARK: - Public properties -

    var presenter: TransactionsPresenterInterface!

    // MARK: - Lifecycle -

    override func viewDidLoad() {
        super.viewDidLoad()
        configureViews()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        setupNavigation()
    }
    
    private func setupNavigation() {
        navigationItem.title = "Tạo giao dịch"
        navigationItem.leftBarButtonItem = UIBarButtonItem(
            image: Asset.Icon.Common.icIosBack.image,
            style: .done,
            target: self,
            action: #selector(didTapBackBarButton)
        )
    }
    
    @objc
    private func didTapBackBarButton() {
        presenter.backTrigger.accept(())
    }

}

// MARK: - Extensions -

extension TransactionsViewController {
    private func configureViews() {
        pinBottonContainerWrapView.setShadowStyle(.shadow4Revert)
        submitButton.setStyle(.primaryDestruction)
        submitButton.setTitle("Tạo giao dịch")
    }
    
    private func configureTableView() {
        
    }
}

enum TransactionCellType {
    case orderItem(viewModel: OrderItemViewModel)
    case addItem
}

extension TransactionCellType: IdentifiableType {
    typealias Identity = Int
    var identity: Int {
        switch self {
        case .orderItem:
            return 1
            
        case .addItem:
            return 2
        }
    }
}

extension TransactionCellType: Equatable {
    static func == (lhs: TransactionCellType, rhs: TransactionCellType) -> Bool {
        return lhs.identity == rhs.identity
    }
}

extension TransactionsViewController {
    typealias Section = AnimatableSectionModel<Int, TransactionCellType>
    typealias DataSource = RxTableViewSectionedAnimatedDataSource<Section>
}

extension TransactionsViewController {
    private func makeDataSource() -> DataSource {
        return DataSource(animationConfiguration: AnimationConfiguration(insertAnimation: .left, reloadAnimation: .left, deleteAnimation: .right)) { (_, tableView, indexPath, type) -> UITableViewCell in
            switch type {
            case let .orderItem(viewModel):
                let cell: OrderItemCell = tableView.dequeueReusableCell(for: indexPath)
                cell.configureCell(viewModel: viewModel)
                return cell
                
            case .addItem:
                let cell: AddOrderItemCell = tableView.dequeueReusableCell(for: indexPath)
                return cell
            }
        }
    }
}
